diff -bruN freeswan-1.9.orig/klips/net/ipsec/ipsec_tunnel.c freeswan-1.9/klips/net/ipsec/ipsec_tunnel.c
--- freeswan-1.9.orig/klips/net/ipsec/ipsec_tunnel.c	Mon Feb 26 19:51:00 2001
+++ freeswan-1.9/klips/net/ipsec/ipsec_tunnel.c	Tue Jun 12 16:35:03 2001
@@ -14,7 +14,7 @@
  * for more details.
  */
 
-char ipsec_tunnel_c_version[] = "RCSID $Id: ipsec_tunnel.c,v 1.137.2.1 2001/02/27 00:51:00 henry Exp $";
+char ipsec_tunnel_c_version[] = "RCSID $Id: ipsec_tunnel.c,v 1.163 2001/06/06 20:28:51 rgb Exp $";
 
 #define __NO_VERSION__
 #include <linux/module.h>
@@ -80,7 +80,7 @@
 #include <net/ip.h>
 #ifdef NETDEV_23
 #include <linux/netfilter_ipv4.h>
-#endif
+#endif /* NETDEV_23 */
 
 #include "radij.h"
 #include "ipsec_encap.h"
@@ -103,6 +103,7 @@
 #ifdef MSS_HACK
 #include <net/tcp.h>		/* TCP options */
 #endif	/* MSS_HACK */
+extern void des_cbc_encrypt(caddr_t, caddr_t, int, caddr_t, caddr_t, int);
 extern void des_ede3_cbc_encrypt(caddr_t, caddr_t, int, caddr_t, caddr_t, caddr_t, caddr_t, int);
 static __u32 zeroes[64];
 
@@ -112,8 +113,6 @@
 #endif /* CONFIG_IPSEC_DEBUG */
 
 int sysctl_ipsec_icmp = 0;
-int sysctl_ipsec_no_eroute_pass = 0;
-int sysctl_ipsec_opportunistic = 0;
 int sysctl_ipsec_tos = 0;
 
 #ifdef CONFIG_IPSEC_DEBUG_
@@ -124,7 +123,10 @@
 	unsigned char *b = bb;
   
 	if (debug_tunnel) {
-		printk(KERN_INFO "klips_debug:ipsec_tunnel_:at %s, len=%d:", s, len);
+		printk(KERN_INFO "klips_debug:ipsec_tunnel_:dmp: "
+		       "at %s, len=%d:",
+		       s,
+		       len);
 		for (i=0; i < len; i++) {
 			if(!(i%16)){
 				printk("\nklips_debug:  ");
@@ -152,9 +154,11 @@
 	 *	Do sanity checking
 	 */
 	if((headroom < 0) || (tailroom < 0) || ((headroom+tailroom) < 0)) {
-		printk(KERN_WARNING "klips_error:skb_copy_expand: "
+		printk(KERN_WARNING
+		       "klips_error:skb_copy_expand: "
 		       "Illegal negative head,tailroom %d,%d\n",
-		       headroom, tailroom);
+		       headroom,
+		       tailroom);
 		return NULL;
 	}
 	/*
@@ -192,9 +196,9 @@
 	/* Set the tail pointer and length */
 	if(skb_tailroom(n) < skb->len) {
 		printk(KERN_WARNING "klips_error:skb_copy_expand: "
-		       "tried to skb_put %ld, %d available.  "
-		       "This should never happen, please report.\n",
-		       (unsigned long int)skb->len, skb_tailroom(n));
+		       "tried to skb_put %ld, %d available.  This should never happen, please report.\n",
+		       (unsigned long int)skb->len,
+		       skb_tailroom(n));
 		dev_kfree_skb(n, FREE_WRITE);
 		return NULL;
 	}
@@ -243,7 +247,9 @@
 	if(skb->mac.raw) 
 		n->mac.raw=skb->mac.raw+offset;
 	memcpy(n->proto_priv, skb->proto_priv, sizeof(skb->proto_priv));
+#ifndef NETDEV_23
 	n->used=skb->used;
+#endif /* !NETDEV_23 */
 	n->pkt_type=skb->pkt_type;
 	n->stamp=skb->stamp;
 	
@@ -265,11 +271,15 @@
 	printk(" ver:%d", ip->version);
 	printk(" tos:%d", ip->tos);
 	printk(" tlen:%d", ntohs(ip->tot_len));
-	printk(" id:%d", ip->id);
-	printk(" frag_off:%d", ip->frag_off);
+	printk(" id:%d", ntohs(ip->id));
+	printk(" %s%s%sfrag_off:%d",
+               ip->frag_off & __constant_htons(IP_CE) ? "CE " : "",
+               ip->frag_off & __constant_htons(IP_DF) ? "DF " : "",
+               ip->frag_off & __constant_htons(IP_MF) ? "MF " : "",
+               (ntohs(ip->frag_off) & IP_OFFSET) << 3);
 	printk(" ttl:%d", ip->ttl);
 	printk(" proto:%d", ip->protocol);
-	printk(" chk:%d", ip->check);
+	printk(" chk:%d", ntohs(ip->check));
 	addrtoa(*((struct in_addr*)(&ip->saddr)), 0, buf, sizeof(buf));
 	printk(" saddr:%s", buf);
 	addrtoa(*((struct in_addr*)(&ip->daddr)), 0, buf, sizeof(buf));
@@ -283,7 +293,8 @@
 		c = ((__u8*)ip) + ip->ihl*4;
 		for(i = 0; i < ntohs(ip->tot_len) - ip->ihl*4; i++ /*, c++*/) {
 			if(!(i % 16)) {
-				printk(KERN_INFO "klips_debug:   @%03x:",
+				printk(KERN_INFO
+				       "klips_debug:   @%03x:",
 				       i);
 			}
 			printk(" %02x", /***/c[i]);
@@ -303,6 +314,7 @@
  *	Locking
  */
  
+#if 0
 DEBUG_NO_STATIC int
 ipsec_tunnel_lock(struct ipsecpriv *prv)
 {
@@ -322,13 +334,16 @@
 	restore_flags(flags);
 	return 1;
 }
+#endif
 
+#if 0
 DEBUG_NO_STATIC void
 ipsec_tunnel_unlock(struct ipsecpriv *prv)
 {
 	prv->locked=0;
 	wake_up(&prv->wait_queue);
 }
+#endif
 #endif /* REAL_LOCKING_P */
 
 DEBUG_NO_STATIC int
@@ -434,9 +449,6 @@
 	__u32   newsrc;			/* The new source SG's IP address */
 	__u32	orgsrc;			/* Original IP source address */
 	__u32	innersrc;		/* Innermost IP source address */
-#ifdef NETDEV_23
-	__u32	route_saddr;		/* source IP used in route lookup */
-#endif /* NETDEV_23 */
 	int	iphlen;			/* IP header length */
 	int	pyldsz;			/* upper protocol payload size */
 	int	headroom;
@@ -464,6 +476,11 @@
 	struct rtable *rt = NULL;
 #endif /* NET_21 */
 	struct sa_id outgoing_said;
+#ifdef NET_21
+	int pass = 0;
+#endif /* NET_21 */
+	int error = 0;
+	uint32_t eroute_pid = 0;
 
 	/*
 	 *	Return if there is nothing to do.  (Does this ever happen?) XXX
@@ -506,10 +523,17 @@
 	   tcpdump being momentarily attached to the interface), make
 	   a copy of our own to modify */
 	if(skb_cloned(skb)) {
-		if ((skb = skb_cow(skb, skb_headroom(skb))) == NULL) {
+		if
+#ifdef SKB_COW_NEW
+	       (skb_cow(skb, skb_headroom(skb)) != 0)
+#else /* SKB_COW_NEW */
+	       ((skb = skb_cow(skb, skb_headroom(skb))) == NULL)
+#endif /* SKB_COW_NEW */
+		{
 			KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 		        	    "klips_error:ipsec_tunnel_start_xmit: "
 				    "skb_cow failed to allocate buffer, dropping.\n" );
+			stats->tx_dropped++;
 			goto cleanup;
 		}
 	}
@@ -572,8 +596,7 @@
 	if ((iph->ihl << 2) != sizeof (struct iphdr)) {
 		KLIPS_PRINT(debug_tunnel,
 			    "klips_debug:ipsec_tunnel_start_xmit: "
-			    "cannot process IP header options yet.  "
-			    "May be mal-formed packet.\n"); /* XXX */
+			    "cannot process IP header options yet.  May be mal-formed packet.\n"); /* XXX */
 		stats->tx_dropped++;
 		goto cleanup;
 	}
@@ -623,6 +646,9 @@
 	er = ipsec_findroute(&matcher);
 	if(er) {
 		outgoing_said = er->er_said;
+		eroute_pid = er->er_pid;
+		er->er_count++;
+		er->er_lasttime = jiffies/HZ;
 	}
 
 	spin_unlock(&eroute_lock);
@@ -632,24 +658,19 @@
 	 * without interference since it is most likely an IKE packet.
 	 */
 	if((ip_chk_addr((unsigned long)iph->saddr) == IS_MYADDR)
-	   && ((!er) || (iph->daddr == outgoing_said.dst.s_addr))) {
-		if(iph->protocol == IPPROTO_UDP) {
-			struct udphdr *udph = (struct udphdr*)((caddr_t)iph + (iph->ihl << 2));
-			if(ntohs(udph->dest) == 500) {
+	   && ((!er)
+	       || (iph->daddr == outgoing_said.dst.s_addr)
+	       || (INADDR_ANY == outgoing_said.dst.s_addr))
+	   && (iph->protocol == IPPROTO_UDP)
+	   && (ntohs(((struct udphdr*)((caddr_t)iph + (iph->ihl << 2)))->dest) == 500)) {
+#ifdef NET_21
+		pass = 1;
+#endif /* NET_21 */
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
 					    "udp/500 IKE packet, sending unprocessed, "
 					    "calling dev_queue_xmit\n"); 
-#if 1
 				goto bypass;
-#else
-				DEV_QUEUE_XMIT(skb, physdev, SOPRI_NORMAL);
-				/* IP_SEND(skb, physdev); */
-				skb = NULL;
-				goto cleanup;
-#endif
-			}
-		}
 	}
 
 	KLIPS_PRINT(debug_tunnel & DB_TN_CROUT,
@@ -660,6 +681,8 @@
 	innersrc = iph->saddr;
 	/* start encapsulation loop here XXX */
 	do {
+		struct tdb *tdbprev = NULL;
+
 		newdst = orgdst = iph->daddr;
 		newsrc = orgsrc = iph->saddr;
 		orgedst = outgoing_said.dst.s_addr;
@@ -667,26 +690,55 @@
 		pyldsz = ntohs(iph->tot_len) - iphlen;
 		max_headroom = max_tailroom = 0;
 		
-		if (er == NULL)	{
-			if(sysctl_ipsec_no_eroute_pass) {
+		if(er == NULL || (outgoing_said.proto==IPPROTO_INT
+				  && outgoing_said.spi==htonl(SPI_DROP))) {
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "no eroute!: calling dev_queue_xmit\n");
-#if 1
+				    "shunt SA of DROP or no eroute: dropping.\n");
+			stats->tx_dropped++;
+			goto cleanup;
+		}
+		
+		if(outgoing_said.proto==IPPROTO_INT
+		   && outgoing_said.spi==htonl(SPI_REJECT)) {
+			KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
+				    "klips_debug:ipsec_tunnel_start_xmit: "
+				    "shunt SA of REJECT: notifying when coded... and dropping.\n");
+			stats->tx_dropped++;
+			goto cleanup;
+		}
+		
+		if(outgoing_said.proto==IPPROTO_INT
+		   && outgoing_said.spi==htonl(SPI_PASS)) {
+#ifdef NET_21
+			pass = 1;
+#endif /* NET_21 */
+			KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
+				    "klips_debug:ipsec_tunnel_start_xmit: "
+				    "shunt SA of PASS: calling dev_queue_xmit\n");
 				goto bypass;
-#else
-				DEV_QUEUE_XMIT(skb, physdev, SOPRI_NORMAL);
-				/* IP_SEND(skb, physdev); */
-				skb = NULL;
-#endif
-			} else {
-				if(sysctl_ipsec_opportunistic && !er) {
+		}
+
+		if(outgoing_said.proto==IPPROTO_INT
+		   && outgoing_said.spi==htonl(SPI_HOLD)) {
+			KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
+				    "klips_debug:ipsec_tunnel_start_xmit: "
+				    "shunt SA of HOLD: will stash when coded..., dropping for now.\n");
+			stats->tx_dropped++;
+			goto cleanup;
+		}
+		
+		if(outgoing_said.proto==IPPROTO_INT
+		   && outgoing_said.spi==htonl(SPI_TRAP)) {
 					struct tdb tdb;
 					struct sockaddr_in src, dst;
 #ifdef CONFIG_IPSEC_DEBUG
 					char bufsrc[ADDRTOA_BUF], bufdst[ADDRTOA_BUF];
 #endif /* CONFIG_IPSEC_DEBUG */
+			struct eroute hold_eroute;
+			struct sa_id hold_said;
 					
+			/* Signal all listening KMds with a PF_KEY ACQUIRE */
 					tdb.tdb_said.proto = iph->protocol;
 					src.sin_family = AF_INET;
 					dst.sin_family = AF_INET;
@@ -723,41 +775,106 @@
 						    ((struct sockaddr_in*)(tdb.tdb_addr_d))->sin_port,
 						    tdb.tdb_said.proto);
 					pfkey_acquire(&tdb);
-				} else {
-					KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
+
+			/* install HOLD eroute */
+			memset((caddr_t)&hold_eroute, 0, sizeof(hold_eroute));
+			memset((caddr_t)&hold_said, 0, sizeof(hold_said));
+
+			hold_said.proto = IPPROTO_INT;
+			hold_said.spi = htonl(SPI_HOLD);
+			hold_said.dst.s_addr = 0L;
+
+			hold_eroute.er_eaddr.sen_len = sizeof(struct sockaddr_encap);
+			hold_eroute.er_emask.sen_len = sizeof(struct sockaddr_encap);
+			hold_eroute.er_eaddr.sen_family = AF_ENCAP;
+			hold_eroute.er_emask.sen_family = AF_ENCAP;
+			hold_eroute.er_eaddr.sen_type = SENT_IP4;
+			hold_eroute.er_emask.sen_type = 255;
+
+			hold_eroute.er_eaddr.sen_ip_src.s_addr = iph->saddr;
+			hold_eroute.er_eaddr.sen_ip_dst.s_addr = iph->daddr;
+			hold_eroute.er_emask.sen_ip_src.s_addr = INADDR_BROADCAST;
+			hold_eroute.er_emask.sen_ip_dst.s_addr = INADDR_BROADCAST;
+			
+			hold_eroute.er_pid = eroute_pid;
+			hold_eroute.er_count = 0;
+			hold_eroute.er_lasttime = jiffies/HZ;
+
+#ifdef IPSEC_CONFIG_FULL_SELECTOR_LIST
+			/* These are ficticious.  Don't uncomment these until
+			   proto, sport and dport exist in the SPDB */
+			hold_eroute.er_proto = iph->protocol;
+			hold_eroute.er_src_port = 
+				(iph->protocol == IPPROTO_UDP
+				 ? ((struct udphdr*) (((caddr_t)iph) + (iph->ihl << 2)))->source
+				 : (iph->protocol == IPPROTO_TCP
+				    ? ((struct tcphdr*)((caddr_t)iph + (iph->ihl << 2)))->source
+				    : 0));
+			hold_eroute.er_dst_port = 
+				(iph->protocol == IPPROTO_UDP
+				 ? ((struct udphdr*) (((caddr_t)iph) + (iph->ihl << 2)))->dest
+				 : (iph->protocol == IPPROTO_TCP
+				    ? ((struct tcphdr*)((caddr_t)iph + (iph->ihl << 2)))->dest
+				    : 0));
+#endif /* IPSEC_CONFIG_FULL_SELECTOR_LIST */
+
+#ifdef CONFIG_IPSEC_DEBUG
+			if (debug_pfkey) {
+				char buf1[64], buf2[64];
+				subnettoa(hold_eroute.er_eaddr.sen_ip_src,
+					  hold_eroute.er_emask.sen_ip_src, 0, buf1, sizeof(buf1));
+				subnettoa(hold_eroute.er_eaddr.sen_ip_dst,
+					  hold_eroute.er_emask.sen_ip_dst, 0, buf2, sizeof(buf2));
+				KLIPS_PRINT(debug_pfkey,
 						    "klips_debug:ipsec_tunnel_start_xmit: "
-						    "no eroute!: dropping.\n");
-					stats->tx_dropped++;
+					    "calling breakeroute and makeroute for %s->%s HOLD eroute.\n",
+					    buf1, buf2);
 				}
-			}
-			goto cleanup;
+#endif /* CONFIG_IPSEC_DEBUG */
+			if (!(ipsec_breakroute(&(hold_eroute.er_eaddr),
+						      &(hold_eroute.er_emask)) == EINVAL)) {
+				KLIPS_PRINT(debug_pfkey,
+					    "klips_debug:ipsec_tunnel_start_xmit: "
+					    "breakeroute should have failed.\n");
+				/* SENDERR(-error); */
+			} else {
+				KLIPS_PRINT(debug_pfkey,
+					    "klips_debug:ipsec_tunnel_start_xmit: "
+					    "HOLD breakeroute found nothing as expected.\n");
 		}
 		
-		/*
-		  If the packet matches an eroute with an SA.proto of IP
-		  tunnelling and 
-		  an SA.spi of '0', then forward the packet unprotected.
-		  XXX -- This should eventually go into an SPD. 
-		*/
-		if((outgoing_said.proto == IPPROTO_IPIP) && (outgoing_said.spi == 0)) {
-			KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
+			if ((error = ipsec_makeroute(&(hold_eroute.er_eaddr),
+						     &(hold_eroute.er_emask),
+						     hold_said,
+						     eroute_pid))) {
+				KLIPS_PRINT(debug_pfkey,
 				    "klips_debug:ipsec_tunnel_start_xmit: "
-				    "passthrough eroute, packet sent.\n");
-#if 1
-			goto bypass;
-#else
-			DEV_QUEUE_XMIT(skb, physdev, SOPRI_NORMAL);
-			/* IP_SEND(skb, physdev); */
-			skb = NULL;
+					    "HOLD makeroute returned %d, failed.\n", error);
+				/* SENDERR(-error); */
+			} else {
+				KLIPS_PRINT(debug_pfkey,
+					    "klips_debug:ipsec_tunnel_start_xmit: "
+					    "HOLD makeroute call successful.\n");
+			}
+			
 			goto cleanup;
-#endif
 		}
 		
 		/*
-		 * The spinlock is to prevent any other process from accessing or deleting
-		 * the tdb while we are using and updating it.
+		  The spinlock is to prevent any other process from
+		  accessing or deleting the TDB hash table or any of the
+		  TDBs while we are using and updating them.
+		  
+		  This is not optimal, but was relatively straightforward
+		  at the time.  A better way to do it has been planned for
+		  more than a year, to lock the hash table and put reference
+		  counts on each TDB instead.  This is not likely to happen
+		  in KLIPS1 unless a volunteer contributes it, but will be
+		  designed into KLIPS2.
 		 */
+		if(tdbprev == NULL) {
 		spin_lock(&tdb_lock);
+		}
 
 		tdbp = gettdb(&outgoing_said);
 		sa_len = satoa(outgoing_said, 0, sa, SATOA_BUF);
@@ -766,8 +883,8 @@
 			spin_unlock(&tdb_lock);
 			KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 				    "klips_debug:ipsec_tunnel_start_xmit: "
-				    "no Tunnel Descriptor Block for SA%s: "
-				    "outgoing packet with no SA, dropped.\n", sa);
+				    "no Tunnel Descriptor Block for SA%s: outgoing packet with no SA, dropped.\n",
+				    sa_len ? sa : " (error)");
 			stats->tx_dropped++;
 			goto cleanup;
 		}
@@ -775,7 +892,8 @@
 		KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 			    "klips_debug:ipsec_tunnel_start_xmit: "
 			    "found Tunnel Descriptor Block -- SA:<%s%s%s> %s\n",
-			    TDB_XFORM_NAME(tdbp), sa);
+			    TDB_XFORM_NAME(tdbp),
+			    sa_len ? sa : " (error)");
 		
 		/*
 		 * How much headroom do we need to be able to apply
@@ -789,9 +907,9 @@
 			if(tdbp->tdb_state == SADB_SASTATE_LARVAL) {
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "TDB in larval state for SA:<%s%s%s> %s, "
-					    "cannot be used yet, dropping packet.\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+					    "TDB in larval state for SA:<%s%s%s> %s, cannot be used yet, dropping packet.\n",
+					    TDB_XFORM_NAME(tdbp),
+					    sa_len ? sa : " (error)");
 				spin_unlock(&tdb_lock);
 				stats->tx_errors++;
 				goto cleanup;
@@ -800,9 +918,9 @@
 			if(tdbp->tdb_state == SADB_SASTATE_DEAD) {
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "TDB in dead state for SA:<%s%s%s> %s, "
-					    "can no longer be used, dropping packet.\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+					    "TDB in dead state for SA:<%s%s%s> %s, can no longer be used, dropping packet.\n",
+					    TDB_XFORM_NAME(tdbp),
+					    sa_len ? sa : " (error)");
 				spin_unlock(&tdb_lock);
 				stats->tx_errors++;
 				goto cleanup;
@@ -813,9 +931,9 @@
 				pfkey_expire(tdbp, 1);
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "replay window counter rolled for SA:<%s%s%s> %s, "
-					    "packet dropped, expiring SA.\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+					    "replay window counter rolled for SA:<%s%s%s> %s, packet dropped, expiring SA.\n",
+					    TDB_XFORM_NAME(tdbp),
+					    sa_len ? sa : " (error)");
 				deltdbchain(tdbp);
 				spin_unlock(&tdb_lock);
 				stats->tx_errors++;
@@ -828,9 +946,9 @@
 				pfkey_expire(tdbp, 1);
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "hard bytes lifetime of SA:<%s%s%s> %s has been reached, "
-					    "SA expired, outgoing packet dropped.\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+					    "hard bytes lifetime of SA:<%s%s%s> %s has been reached, SA expired, outgoing packet dropped.\n",
+					    TDB_XFORM_NAME(tdbp),
+					    sa_len ? sa : " (error)");
 				deltdbchain(tdbp);
 				spin_unlock(&tdb_lock);
 				stats->tx_errors++;
@@ -838,14 +956,15 @@
 			}
 			if(tdbp->tdb_lifetime_bytes_s &&
 			   (tdbp->tdb_lifetime_bytes_c > tdbp->tdb_lifetime_bytes_s)) {
+				if(tdbp->tdb_state != SADB_SASTATE_DYING) {
 				pfkey_expire(tdbp, 0);
+				}
 				tdbp->tdb_state = SADB_SASTATE_DYING;
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "soft bytes lifetime of SA:<%s%s%s> %s has been reached, "
-					    "SA expiring, soft expire message sent up, "
-					    "outgoing packet still processed.\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+					    "soft bytes lifetime of SA:<%s%s%s> %s has been reached, SA expiring, soft expire message sent up, outgoing packet still processed.\n",
+					    TDB_XFORM_NAME(tdbp),
+					    sa_len ? sa : " (error)");
 			}
 
 			if(tdbp->tdb_lifetime_addtime_h &&
@@ -854,9 +973,9 @@
 				pfkey_expire(tdbp, 1);
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "hard addtime lifetime of SA:<%s%s%s> %s has been reached, "
-					    "SA expired, outgoing packet dropped.\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+					    "hard addtime lifetime of SA:<%s%s%s> %s has been reached, SA expired, outgoing packet dropped.\n",
+					    TDB_XFORM_NAME(tdbp),
+					    sa_len ? sa : " (error)");
 				deltdbchain(tdbp);
 				spin_unlock(&tdb_lock);
 				stats->tx_errors++;
@@ -865,14 +984,15 @@
 			if(tdbp->tdb_lifetime_addtime_s &&
 			   ((jiffies / HZ) - tdbp->tdb_lifetime_addtime_c >
 			    tdbp->tdb_lifetime_addtime_s)) {
+				if(tdbp->tdb_state != SADB_SASTATE_DYING) {
 				pfkey_expire(tdbp, 0);
+				}
 				tdbp->tdb_state = SADB_SASTATE_DYING;
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "soft addtime lifetime of SA:<%s%s%s> %s has been reached, "
-					    "SA expiring, soft expire message sent up, "
-					    "outgoing packet still processed.\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+					    "soft addtime lifetime of SA:<%s%s%s> %s has been reached, SA expiring, soft expire message sent up, outgoing packet still processed.\n",
+					    TDB_XFORM_NAME(tdbp),
+					    sa_len ? sa : " (error)");
 			}
 
 			if(tdbp->tdb_lifetime_usetime_c) {
@@ -882,9 +1002,9 @@
 					pfkey_expire(tdbp, 1);
 					KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 						    "klips_debug:ipsec_tunnel_start_xmit: "
-						    "hard usetime lifetime of SA:<%s%s%s> %s has been reached, "
-						    "SA expired, outgoing packet dropped.\n",
-						    TDB_XFORM_NAME(tdbp), sa);
+						    "hard usetime lifetime of SA:<%s%s%s> %s has been reached, SA expired, outgoing packet dropped.\n",
+						    TDB_XFORM_NAME(tdbp),
+						    sa_len ? sa : " (error)");
 					deltdbchain(tdbp);
 					spin_unlock(&tdb_lock);
 					stats->tx_errors++;
@@ -893,14 +1013,15 @@
 				if(tdbp->tdb_lifetime_usetime_s &&
 				   ((jiffies / HZ) - tdbp->tdb_lifetime_usetime_c >
 				    tdbp->tdb_lifetime_usetime_s)) {
+					if(tdbp->tdb_state != SADB_SASTATE_DYING) {
 					pfkey_expire(tdbp, 0);
+					}
 					tdbp->tdb_state = SADB_SASTATE_DYING;
 					KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 						    "klips_debug:ipsec_tunnel_start_xmit: "
-						    "soft usetime lifetime of SA:<%s%s%s> %s has been reached, "
-						    "SA expiring, soft expire message sent up, "
-						    "outgoing packet still processed.\n",
-						    TDB_XFORM_NAME(tdbp), sa);
+						    "soft usetime lifetime of SA:<%s%s%s> %s has been reached, SA expiring, soft expire message sent up, outgoing packet still processed.\n",
+						    TDB_XFORM_NAME(tdbp),
+						    sa_len ? sa : " (error)");
 				}
 			}
 
@@ -909,9 +1030,9 @@
 				pfkey_expire(tdbp, 1);
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "hard packets lifetime of SA:<%s%s%s> %s has been reached, "
-					    "SA expired, outgoing packet dropped.\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+					    "hard packets lifetime of SA:<%s%s%s> %s has been reached, SA expired, outgoing packet dropped.\n",
+					    TDB_XFORM_NAME(tdbp),
+					    sa_len ? sa : " (error)");
 				deltdbchain(tdbp);
 				spin_unlock(&tdb_lock);
 				stats->tx_errors++;
@@ -919,21 +1040,23 @@
 			}
 			if(tdbp->tdb_lifetime_packets_s &&
 			   (tdbp->tdb_lifetime_packets_c > tdbp->tdb_lifetime_packets_s)) {
+				if(tdbp->tdb_state != SADB_SASTATE_DYING) {
 				pfkey_expire(tdbp, 0);
+				}
 				tdbp->tdb_state = SADB_SASTATE_DYING;
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "soft packets lifetime of SA:<%s%s%s> %s has been reached, "
-					    "SA expiring, soft expire message sent up, "
-					    "outgoing packet still processed.\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+					    "soft packets lifetime of SA:<%s%s%s> %s has been reached, SA expiring, soft expire message sent up, outgoing packet still processed.\n",
+					    TDB_XFORM_NAME(tdbp),
+					    sa_len ? sa : " (error)");
 			}
 
 			headroom = tailroom = 0;
 			KLIPS_PRINT(debug_tunnel & DB_TN_CROUT,
 				    "klips_debug:ipsec_tunnel_start_xmit: "
 				    "calling room for <%s%s%s>, SA:%s\n", 
-				    TDB_XFORM_NAME(tdbp), sa);
+				    TDB_XFORM_NAME(tdbp),
+				    sa_len ? sa : " (error)");
 			switch(tdbp->tdb_said.proto) {
 #ifdef CONFIG_IPSEC_AH
 			case IPPROTO_AH:
@@ -943,16 +1066,16 @@
 #ifdef CONFIG_IPSEC_ESP
 			case IPPROTO_ESP:
 				switch(tdbp->tdb_encalg) {
+#ifdef CONFIG_IPSEC_ENC_DES
+				case ESP_DES:
+					headroom += sizeof(struct esp);
+					break;
+#endif /* CONFIG_IPSEC_ENC_DES */
 #ifdef CONFIG_IPSEC_ENC_3DES
 				case ESP_3DES:
 					headroom += sizeof(struct esp);
 					break;
 #endif /* CONFIG_IPSEC_ENC_3DES */
-#ifdef CONFIG_IPSEC_ENC_NULL
-				case ESP_NULL:
-					headroom += offsetof(struct esp, esp_iv);
-					break;
-#endif /* CONFIG_IPSEC_ENC_NULL */
 				default:
 					spin_unlock(&tdb_lock);
 					stats->tx_errors++;
@@ -1019,8 +1142,7 @@
 		
 		KLIPS_PRINT(debug_tunnel & DB_TN_CROUT,
 			    "klips_debug:ipsec_tunnel_start_xmit: "
-			    "existing head,tailroom: %d,%d "
-			    "before applying xforms with head,tailroom: %d,%d .\n",
+			    "existing head,tailroom: %d,%d before applying xforms with head,tailroom: %d,%d .\n",
 			    skb_headroom(skb), skb_tailroom(skb),
 			    max_headroom, max_tailroom);
 		
@@ -1030,18 +1152,21 @@
 		mtudiff = prv->mtu + tot_headroom + tot_tailroom - physmtu;
 
 		KLIPS_PRINT(debug_tunnel & DB_TN_CROUT,
-			    "klips_debug:ipsec_tunnel_start_xmit: mtu:%d physmtu:%d "
-			    "tothr:%d tottr:%d mtudiff:%d ippkttotlen:%d\n",
+			    "klips_debug:ipsec_tunnel_start_xmit: "
+			    "mtu:%d physmtu:%d tothr:%d tottr:%d mtudiff:%d ippkttotlen:%d\n",
 			    prv->mtu, physmtu,
 			    tot_headroom, tot_tailroom, mtudiff, ntohs(iph->tot_len));
 		if(mtudiff > 0) {
+			int newmtu = physmtu - (tot_headroom + ((tot_tailroom + 2) & ~7) + 5);
+
 			KLIPS_PRINT(debug_tunnel & DB_TN_CROUT,
 				    "klips_info:ipsec_tunnel_start_xmit: "
-				    "dev %s mtu of %d decreased by %d\n",
+				    "dev %s mtu of %d decreased by %d to %d\n",
 				    dev->name,
 				    prv->mtu,
-				    prv->mtu - (physmtu - tot_headroom - tot_tailroom));
-			prv->mtu = physmtu - (tot_headroom + tot_tailroom + 7);	/* add some slop? */
+				    prv->mtu - newmtu,
+				    newmtu);
+			prv->mtu = newmtu;
 #ifdef NET_21
 #if 0
 			skb->dst->pmtu = prv->mtu; /* RGB */
@@ -1053,6 +1178,34 @@
 #endif /* NET_21 */
 		}
 		
+		/* If the sender is doing PMTU discovery, and the packet doesn't fit within
+		 * prv->mtu, notify him (unless it was an ICMP packet) and drop it.
+		 * Note: buggy firewall configuration may prevent the ICMP packet from getting back.
+		 * Note2: Linux 2.4.x is trying to do PMTU discovery on ICMP packets, but this seems
+		 * bogus, and should be fixed in the kernel.
+		 */
+		if (iph->frag_off & __constant_htons(IP_DF)
+			&& prv->mtu < ntohs(iph->tot_len))
+		{
+			int notify = iph->protocol != IPPROTO_ICMP
+				     && (iph->frag_off & __constant_htons(IP_OFFSET)) == 0;
+
+			spin_unlock(&tdb_lock);
+			KLIPS_PRINT(debug_tunnel & DB_TN_CROUT,
+				    "klips_debug:ipsec_tunnel_start_xmit: "
+				    "fragmentation needed and DF set; %sdropping packet\n",
+				    notify ? "sending ICMP and " : "");
+			if (notify)
+				ICMP_SEND(skb,
+					  ICMP_DEST_UNREACH,
+					  ICMP_FRAG_NEEDED,
+					  prv->mtu,
+					  physdev);
+			stats->tx_dropped++;
+			goto cleanup;
+		}
+
+		
 #ifdef MSS_HACK
 		/*
 		 * If this is a transport mode TCP packet with
@@ -1065,7 +1218,8 @@
 			if (tcph->syn && !tcph->ack) {
 				if(!ipsec_adjust_mss(skb, tcph, prv->mtu)) {
 					spin_unlock(&tdb_lock);
-					printk(KERN_WARNING "klips: "
+					printk(KERN_WARNING
+					       "klips_warning:ipsec_tunnel_start_xmit: "
 					       "ipsec_adjust_mss() failed\n");
 					stats->tx_errors++;
 					goto cleanup;
@@ -1077,8 +1231,8 @@
 		if(!hard_header_stripped) {
 			if((saved_header = kmalloc(hard_header_len, GFP_ATOMIC)) == NULL) {
 				spin_unlock(&tdb_lock);
-				printk(KERN_WARNING "klips_debug:ipsec_tunnel_start_xmit: Failed, "
-				       "tried to allocate %d bytes for temp hard_header.\n", 
+				printk(KERN_WARNING "klips_debug:ipsec_tunnel_start_xmit: "
+				       "Failed, tried to allocate %d bytes for temp hard_header.\n", 
 				       hard_header_len);
 				stats->tx_errors++;
 				goto cleanup;
@@ -1089,8 +1243,7 @@
 			if(skb->len < hard_header_len) {
 				spin_unlock(&tdb_lock);
 				printk(KERN_WARNING "klips_error:ipsec_tunnel_start_xmit: "
-				       "tried to skb_pull hhlen=%d, %d available.  "
-				       "This should never happen, please report.\n",
+				       "tried to skb_pull hhlen=%d, %d available.  This should never happen, please report.\n",
 				       hard_header_len, (int)(skb->len));
 				stats->tx_errors++;
 				goto cleanup;
@@ -1144,8 +1297,9 @@
 			skb = tskb;
 			if (!skb) {
 				spin_unlock(&tdb_lock);
-				printk(KERN_WARNING "klips_debug:ipsec_tunnel_start_xmit: Failed, "
-				       "tried to allocate %d head and %d tailroom\n", 
+				printk(KERN_WARNING
+				       "klips_debug:ipsec_tunnel_start_xmit: "
+				       "Failed, tried to allocate %d head and %d tailroom\n", 
 				       max_headroom, max_tailroom);
 				stats->tx_errors++;
 				goto cleanup;
@@ -1190,7 +1344,8 @@
 			KLIPS_PRINT(debug_tunnel & DB_TN_OXFS,
 				    "klips_debug:ipsec_tunnel_start_xmit: "
 				    "calling output for <%s%s%s>, SA:%s\n", 
-				    TDB_XFORM_NAME(tdbp), sa);
+				    TDB_XFORM_NAME(tdbp),
+				    sa_len ? sa : " (error)");
 			
 			switch(tdbp->tdb_said.proto) {
 #ifdef CONFIG_IPSEC_AH
@@ -1201,16 +1356,16 @@
 #ifdef CONFIG_IPSEC_ESP
 			case IPPROTO_ESP:
 				switch(tdbp->tdb_encalg) {
+#ifdef CONFIG_IPSEC_ENC_DES
+				case ESP_DES:
+					headroom += sizeof(struct esp);
+					break;
+#endif /* CONFIG_IPSEC_ENC_DES */
 #ifdef CONFIG_IPSEC_ENC_3DES
 				case ESP_3DES:
 					headroom += sizeof(struct esp);
 					break;
 #endif /* CONFIG_IPSEC_ENC_3DES */
-#ifdef CONFIG_IPSEC_ENC_NULL
-				case ESP_NULL:
-					headroom += offsetof(struct esp, esp_iv);
-					break;
-#endif /* CONFIG_IPSEC_ENC_NULL */
 				default:
 					spin_unlock(&tdb_lock);
 					stats->tx_errors++;
@@ -1259,9 +1414,9 @@
 				    headroom, tailroom, tdbp->tdb_said.proto);
 			if(skb_headroom(skb) < headroom) {
 				spin_unlock(&tdb_lock);
-				printk(KERN_WARNING "klips_error:ipsec_tunnel_start_xmit: "
-				       "tried to skb_push headroom=%d, %d available.  "
-				       "This should never happen, please report.\n",
+				printk(KERN_WARNING
+				       "klips_error:ipsec_tunnel_start_xmit: "
+				       "tried to skb_push headroom=%d, %d available.  This should never happen, please report.\n",
 				       headroom, skb_headroom(skb));
 				stats->tx_errors++;
 				goto cleanup;
@@ -1270,9 +1425,9 @@
 			ilen = skb->len - tailroom;
 			if(skb_tailroom(skb) < tailroom) {
 				spin_unlock(&tdb_lock);
-				printk(KERN_WARNING "klips_error:ipsec_tunnel_start_xmit: "
-				       "tried to skb_put %d, %d available.  "
-				       "This should never happen, please report.\n",
+				printk(KERN_WARNING
+				       "klips_error:ipsec_tunnel_start_xmit: "
+				       "tried to skb_put %d, %d available.  This should never happen, please report.\n",
 				       tailroom, skb_tailroom(skb));
 				stats->tx_errors++;
 				goto cleanup;
@@ -1286,8 +1441,7 @@
 			if(len > 0xfff0) {
 				spin_unlock(&tdb_lock);
 				printk(KERN_WARNING "klips_error:ipsec_tunnel_start_xmit: "
-				       "tot_len (%d) > 65520.  "
-				       "This should never happen, please report.\n",
+				       "tot_len (%d) > 65520.  This should never happen, please report.\n",
 				       len);
 				stats->tx_errors++;
 				goto cleanup;
@@ -1304,20 +1458,19 @@
 				espp->esp_rpl = htonl(++(tdbp->tdb_replaywin_lastseq));
 				
 				switch(tdbp->tdb_encalg) {
-#if defined(CONFIG_IPSEC_ENC_3DES)
+#if defined(CONFIG_IPSEC_ENC_DES) || defined(CONFIG_IPSEC_ENC_3DES)
 #ifdef CONFIG_IPSEC_ENC_3DES
-				case ESP_3DES:
+				case ESP_DES:
 #endif /* CONFIG_IPSEC_ENC_3DES */
+#ifdef CONFIG_IPSEC_ENC_3DES
+				case ESP_3DES:
+#endif /* defined(CONFIG_IPSEC_ENC_DES) || CONFIG_IPSEC_ENC_3DES */
 					iv[0] = *((__u32*)&(espp->esp_iv)    ) =
 						((__u32*)(tdbp->tdb_iv))[0];
 					iv[1] = *((__u32*)&(espp->esp_iv) + 1) =
 						((__u32*)(tdbp->tdb_iv))[1];
 					break;
 #endif /* defined(CONFIG_IPSEC_ENC_3DES) */
-#ifdef CONFIG_IPSEC_ENC_NULL
-				case ESP_NULL:
-					break;
-#endif /* CONFIG_IPSEC_ENC_NULL */
 				default:
 					spin_unlock(&tdb_lock);
 					stats->tx_errors++;
@@ -1339,6 +1492,13 @@
 				iph->protocol = IPPROTO_ESP;
 				
 				switch(tdbp->tdb_encalg) {
+#ifdef CONFIG_IPSEC_ENC_DES
+                                case ESP_DES:
+                                       des_cbc_encrypt(idat, idat, ilen,
+                                                       (caddr_t)tdbp->tdb_key_e,
+                                                       (caddr_t)iv, 1);
+                                       break;
+#endif /* CONFIG_IPSEC_ENC_DES */
 #ifdef CONFIG_IPSEC_ENC_3DES
 				case ESP_3DES:
 					des_ede3_cbc_encrypt(idat, idat, ilen,
@@ -1348,10 +1508,6 @@
 							     (caddr_t)iv, 1);
 					break;
 #endif /* CONFIG_IPSEC_ENC_3DES */
-#ifdef CONFIG_IPSEC_ENC_NULL
-				case ESP_NULL:
-					break;
-#endif /* CONFIG_IPSEC_ENC_NULL */
 				default:
 					spin_unlock(&tdb_lock);
 					stats->tx_errors++;
@@ -1359,7 +1515,10 @@
 				}
 				
 				switch(tdbp->tdb_encalg) {
-#if defined(CONFIG_IPSEC_ENC_3DES)
+#if  defined(CONFIG_IPSEC_ENC_DES) || defined(CONFIG_IPSEC_ENC_3DES)
+#ifdef CONFIG_IPSEC_ENC_DES
+                               case ESP_DES:
+#endif /* CONFIG_IPSEC_ENC_DES */
 #ifdef CONFIG_IPSEC_ENC_3DES
 				case ESP_3DES:
 #endif /* CONFIG_IPSEC_ENC_3DES */
